EDIT - bug #10034

Flat feature tree throws exception
04/06/2022 09:43 AM - Katja Luther

Status: Closed Start date: 05/02/2022
Priority: Priority14 Due date: 05/06/2022
Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.32

Severity: normal Found in Version:

Description

mail WB:

fir Mexico wollte ich einen neuen, sehr reduzierten feature tree erzeugen:

Beim Speichern kommt folgender Fehler.
Das lag anscheindend daran, dass ich ,Flat* auswahlt hatte. Geht ohnehin nicht, da ich die distribution vergessen hatte.
Dieser hier

lie3 sich mit oder ohne distribution speichern.
HG
W

Associated revisions

Revision 428e9ed2 - 06/01/2022 09:09 AM - Katja Luther

ref #10034: check dirty nodes at the beginning of move operation.

Revision 46fc1532 - 06/02/2022 02:30 PM - Katja Luther
ref #10034: better handling of messages

History

#1 - 04/06/2022 05:49 PM - Andreas Miller

Error was:

last remote method : http://132.248.13.83:8080/cdmserver/cdm_flora_mexico/remoting/termnode.service
last remote request client time : 2022-04-05T13:45:59.044
last remote request response header time : Tue, 05 Apr 2022 19:43:34 GMT
client error time : 2022-04-05T13:45:59.478
login : w.berendsohn
editor version : 5.30.0
server : 132.248.13.83 (Mexico) / cdm_flora_mexico
schema version : 5.29.0.0.20211122
os : Windows 10 10.0 amdé64
java : 1.8.0_321
java.lang.Exception: The parent node does not exist.
at eu.etaxonomy.cdm.api.service.TermNodeServiceImpl.addChildNode (TermNodeServiceImpl. java:164)
at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)
at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodIn
vocation. java:190)
at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation
.java:157)
at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (Tran
sactionInterceptor. java:99)
at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Tr
ansactionAspectSupport.java:283)

#2 - 04/06/2022 05:56 PM - Andreas Miiller
- Target version changed from Unassigned CDM tickets to Release 5.32

The problem does only seem to appear if you try to move a node before you save. If you try to move there comes a message saying that moving is
only possible after saving. It looks like this case is not handled correctly.

Moving to current milestone as this is probably fast to fix.
#3 - 04/27/2022 12:48 PM - Andreas Miiller

- Due date set to 05/06/2022
- Start date set to 05/02/2022

#4 - 05/31/2022 02:43 PM - Katja Luther
Could not reproduce this problem with the actual nightly build.
Steps | tried to reproduce the problem:

e create a new tree

e add one or more features
set flat flag

® save

create new tree

set flat flag
* add one or more features

® save

#5 - 06/01/2022 01:58 AM - Andreas Miiller

- Status changed from New to In Progress

Andreas Muller wrote in #note-2:

The problem does only seem to appear if you try to move a node before you save. If you try to move there comes a message saying that moving
is only possible after saving. It looks like this case is not handled correctly.

Did you try to move? According to "Steps | tried" you didn't.

#6 - 06/02/2022 02:33 PM - Katja Luther
- Status changed from In Progress to Resolved
- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 0 to 50

Now moving unsaved nodes is handled correctly. Please reviw.

#7 - 06/22/2022 07:27 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

- Priority changed from New to Priority14

The initial issue is fixed (or workarounded) correctly.

However, the labeling of the tree still behaves strange sometimes. If you add a child the label is reverted to "empty representation". Usually after
saving this is corrected. However, when playing around | also got the following exception 2x but could not repeat it in an reproducable way:

last remote method : https://test.e-taxonomy.eu:443/cdmserver/rem_conf_am/remoting/termnode.service
last remote request client time : 2022-06-22T19:13:56.346

last remote request response header time : Wed, 22 Jun 2022 17:13:56 GMT

client error time : 2022-06-22T19:13:56.372
login

editor
server
schema

admin
version : 5.32.0.202206221047
test.e-taxonomy.eu (edit-test) / rem_conf_am
version : 5.29.0.0.20211122

os : Windows Server 2012 R2 6.3 amdo64

java

1.8.0_131

java.lang.Exception: The parent node does not exist.

at
at

eu.etaxonomy.cdm.api.service.TermNodeServiceImpl.addChildNode (TermNodeServiceImpl. java:165)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokedJoinpoint (ReflectiveMethodInvocation
.Java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15

7)
at

org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (TransactionI

nterceptor. java:99)

at

org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Transactio

nAspectSupport. java:283)

at
6)
at
9)
at
at
at
at
at
at
at
at

org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterceptor. java:9
org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)
com.sun.proxy.$Proxy914.addChildNode (Unknown Source)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:333)
org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMethodInvocation

.java:190)

at
7)
at

ceptor.

at
9)
at
at
at
at
at
at
at
at

r.Jjava:

at

org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:15

org.springframework.remoting.support.RemoteInvocationTraceInterceptor.invoke (RemotelnvocationTracelnter
java:78)
org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvocation. java:17

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)
com.sun.proxy.$Proxyl207.addChildNode (Unknown Source)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)

org.springframework.remoting. support.RemoteInvocation.invoke (RemoteInvocation. java:212)
eu.etaxonomy.cdm.api.remoting.DebuggingRemoteInvocationExecutor.invoke (DebuggingRemotelInvocationExecuto
52)

org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemoteInvocationBasedExporter

.Java:78)

at

org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResult (Remotelnvocati

onBasedExporter. java:114)

at

org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvokerServiceExp

orter.java:80)

at
at
at
at
at
at
at
at
at
at
at
at

at

org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdapter. java:51)
org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:967)
org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:901)
org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet.java:970)
org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet.java:872)
javax.servlet.http.HttpServlet.service (HttpServlet. java:707)
org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet.java:846)
javax.servlet.http.HttpServlet.service (HttpServlet. java:790)

org.eclipse. jetty.servlet.ServletHolder$NotAsyncServlet.service (ServletHolder. java:1395)
org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:755)
org.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1617)
org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:317

org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSecurityInterc

eptor.java:127)

at

org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (FilterSecurityInte

rceptor.java:91)

at

at

org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:331

org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTranslationFilter.
java:114)

at org.springframework.security.web.

at org.springframework.security.web.

137)

at org.springframework.security.web.

at org.springframework.security.web.

ntextHolderAwareRequestFilter. java:170)

at org.springframework.security.web.

at org.springframework.security.web.

java:63)

at org.springframework.security.web.

at org.springframework.security.web

henticationFilter. java:215)

at
at

at
at

at
at
at

at

org

org.

org.
org.

org.
org.
org.

org

.springframework.

.springframework.

springframework.

springframework.
springframework.

springframework.
springframework.
springframework.

stenceFilter. java:105)

at org.springframework.

at org.springframework.security.web

security.web
security.web

security.web

1 (WebAsyncManagerIntegrationFilter. java:56)

at
at

at
at
at
at
at
at
at
at

at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at
at

org

org.

org.
org.
org.
org.
org.

.springframework.
springframework.

springframework.
springframework.
springframework.
springframework.

eu.etaxonomy.cdm.servlet.DateHeaderFilter.doFilter (DateHeaderFilter. java:56)

org

org.

org.
org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eu.etaxonomy.cdm.server.logging.InstancelLogWrapper.handle (InstanceLogWrapper.java:48)

.handler.ContextHandlerCollection.handle (ContextHandlerCollection. java:221)

org

org.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.
.eclipse.
eclipse.
eclipse.

org

org.
org.

.eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1604)
springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodingFilter. java:19

.eclipse.
eclipse.
eclipse.
eclipse.
eclipse.

jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.

jetty

jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.
jetty.

jetty

server.
server
Server
server.
server
server.

server.
server.
server.
server
server.

.Server
server.
server.
server
server.
server.
server

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.

security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilter. java:
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.

security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFilter.
web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:

web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:331

security.web.FilterChainProxy.doFilterInternal (FilterChainProxy.java:214)
security.web.FilterChainProxy.doFilter (FilterChainProxy.java:177)
web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterProxy. java:347)
web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy.java:263)
eclipse.jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1604)

springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1596)
servlet.ServletHandler.doHandle (ServletHandler. java:545)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:590)

handler.HandlerWrapper.handle (HandlerWrapper. java:127)

.handler.ScopedHandler.nextHandle (ScopedHandler
.session.SessionHandler.doHandle (SessionHandler
handler.ScopedHandler.nextHandle (ScopedHandler
.handler.ContextHandler.doHandle (ContextHandler

. java
. java

. java
. java

:235)
:1607)
:233)
:1297)

handler.ScopedHandler.nextScope (ScopedHandler. java:188)

servlet.ServletHandler.doScope (ServletHandler. java:485)

session.SessionHandler.doScope (SessionHandler.java:1577)
handler.ScopedHandler.nextScope (ScopedHandler. java:186)
handler.ContextHandler.doScope (ContextHandler. java:1212)

.handler.ScopedHandler.handle (ScopedHandler. java:141)

handler.HandlerWrapper.handle (HandlerWrapper. java:127)

handler.HandlerWrapper.handle (HandlerWrapper. java:127)

Server.handle (Server. java:500)

HttpChannel.handle (HttpChannel. java:375)

.HttpChannel.lambda$handle$1l (HttpChannel. java:383)
HttpChannel.dispatch (HttpChannel. java:547)

.HttpConnection.onFillable (HttpConnection. java:270)
io.AbstractConnection$ReadCallback.succeeded (AbstractConnection. java:311)
io.FillInterest.fillable(FillInterest.java:103)
io.ChannelEndPoint$2.run (ChannelEndPoint. java:117)
util.thread.strategy.EatWhatYouKill.runTask (EatWhatYouKill. java:336)
.util.thread.strategy.EatWhatYouKill.doProduce (EatWhatYouKill. java:313)

116)
java:

java:

java:

FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy. java:331
session.SessionManagementFilter.doFilter (SessionManagementFilter. java:
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:331
servletapi.SecurityContextHolderAwareRequestFilter.doFilter (SecurityCo
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:331
savedrequest .RequestCacheAwareFilter.doFilter (RequestCacheAwareFilter.
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:331

.authentication.www.BasicAuthenticationFilter.doFilterInternal (BasicAut

331

331

66)

331

.context.SecurityContextPersistenceFilter.doFilter (SecurityContextPersi
.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainProxy.java:331

.context.request.async.WebAsyncManagerIntegrationFilter.doFilterInterna
at
at
at

org

org.

org

org
org

.eclipse.
eclipse.
.eclipse.

.eclipse.

.eclipse

jetty.
jetty.
jetty.

jetty.
.Jjetty.

util.
util.
util.

util.

util

thread.
thread.
thread.

thread.
.thread.

strategy.EatWhatYouKill.tryProduce (EatWhatYouKill. java:171)
strategy.EatWhatYouKill.run (EatWhatYouKill. java:129)
ReservedThreadExecutor$ReservedThread. run (ReservedThreadExecutor. java:388

QueuedThreadPool.rundob (QueuedThreadPool. java:806)
QueuedThreadPool$Runner.run (QueuedThreadPool. java:938)

java.lang.Thread.run (Thread. java:748)

We may handle the remaining/related issues in a separate ticket with lower priority as feature tree creation is not done so often and things will change
with upcoming model changes for terms.

#8 - 06/22/2022 07:27 PM - Andreas Miiller
- % Done changed from 50 to 80

#9 - 07/29/2022 03:26 PM - Andreas Miiller
- % Done changed from 80 to 100

Moved open issues to #10053 and close this ticket.

#10 - 07/29/2022 03:26 PM - Andreas Miiller
- Status changed from Feedback to Closed
https://dev.e-taxonomy.eu/redmine/issues/10053
http://www.tcpdf.org

